#include<bits/stdc++.h>
using namespace std;
int main(){
	#define int long long
	const int MOD = 1e9+7;
	int m;
	cin>>m;
	int x[m];
	int y[m];
	int res[m];
	pair<int, int> tacka;
	int tr = 0;
	int zbir = 0;
	int zbirx = 0;
	int zbiry = 0;
	int proizvod = 0; 
	for(int i=0;i<m;i++){
		cin>>x[i]>>y[i];
		zbirx+=x[i];
		zbirx%=MOD;
		zbiry+=y[i];
		zbiry%=MOD;
		proizvod+=(x[i]*y[i]);
		proizvod%=MOD;
		if(i==0){
			tacka.first = x[i];
			tacka.second = y[i];
			res[i] = 0;
			tr = 0;
			continue;
		}
		tr += abs((x[i]-tacka.first)*(y[i]-tacka.second));
		tr%=MOD;
		for(int j=0;j<=i;j++){
			pair<int,int> tacka2 = {x[i], y[j]};
			pair<int,int> tacka3 = {x[j], y[i]};
			int rez2 = 0;
			int rez3 = 0;
			rez2+= proizvod;
			rez2-=(y[j]*zbirx);
			rez2-=(x[i]*zbiry);
			rez2%=MOD;
			rez2+=((i+1)*x[i]*y[j]);
			rez2 = abs(rez2);
			rez2%=MOD;
			
			rez3+= proizvod;
			rez3-=(y[i]*zbirx);
			rez3-=(x[j]*zbiry);
			rez3%=MOD;
			rez3+=((i+1)*x[j]*y[i]);
			rez3 = abs(rez3);
			rez3%=MOD;
			tr = max({tr, rez2, rez3});
			if(tr==rez2){
				tacka = tacka2;
			}
			else if(tr==rez3){
				tacka = tacka3;
			}
		}
		res[i] = tr;
	}
	for(int i=0;i<m;i++) cout<<res[i]<<endl;
}